(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("prop-types"), require("react"));
	else if(typeof define === 'function' && define.amd)
		define(["prop-types", "react"], factory);
	else if(typeof exports === 'object')
		exports["re-atom"] = factory(require("prop-types"), require("react"));
	else
		root["re-atom"] = factory(root["PropTypes"], root["React"]);
})(this, function(__WEBPACK_EXTERNAL_MODULE_6__, __WEBPACK_EXTERNAL_MODULE_7__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// identity function for calling harmony imports with the correct context
/******/ 	__webpack_require__.i = function(value) { return value; };
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 8);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (immutable) */ __webpack_exports__["b"] = warning;
/* harmony export (immutable) */ __webpack_exports__["i"] = mapObjIndexed;
/* harmony export (immutable) */ __webpack_exports__["d"] = mapObj;
/* harmony export (immutable) */ __webpack_exports__["a"] = compose;
/* unused harmony export assoc */
/* unused harmony export prop */
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "c", function() { return isIterator; });
/* unused harmony export lens */
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "h", function() { return view; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "f", function() { return over; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "g", function() { return set; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "e", function() { return lensProp; });
var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function warning(condition, message) {
  if (!condition && (typeof console === 'undefined' ? 'undefined' : _typeof(console)) !== undefined) {
    console.error('Warning: ' + message);
    try {
      // This error was thrown as a convenience so that you can use this stack
      // to find the callsite that caused this warning to fire.
      throw new Error(message);
    } catch (e) {}
  }
}

function mapObjIndexed(fn, obj) {
  return Object.keys(obj || {}).reduce(function (r, key) {
    return Object.assign(r, _defineProperty({}, key, fn(obj[key], key)));
  }, {});
}

function mapObj(fn, obj) {
  return Object.keys(obj || {}).reduce(function (r, key) {
    return Object.assign(r, _defineProperty({}, key, fn(obj[key])));
  }, {});
}

function compose() {
  for (var _len = arguments.length, fns = Array(_len), _key = 0; _key < _len; _key++) {
    fns[_key] = arguments[_key];
  }

  var outerFn = fns.pop();

  return function () {
    return fns.reduceRight(function (acc, fn) {
      return fn(acc);
    }, outerFn.apply(undefined, arguments));
  };
}

// XXX: wrap in currying goodness
// XXX: check transpilation of { ...obj }
var assoc = function assoc(p) {
  return function (val, obj) {
    return _extends({}, obj, _defineProperty({}, p, val));
  };
};
var prop = function prop(p) {
  return function (obj) {
    return obj[p];
  };
};

var isIterator = function isIterator(o) {
  return o && typeof o.next === 'function';
};

// Simple van Laarhoven lens implementation

var fmap = function fmap(fn, functor) {
  return functor.map(fn);
};

var Identity = function Identity(val) {
  return {
    val: val,
    map: function map(f) {
      return Identity(f(val));
    }
  };
};

var Constantly = function Constantly(val) {
  return {
    val: val,
    map: function map(f) {
      return this;
    }
  };
};

var lens = function lens(getter, setter) {
  return function (vf) {
    return function (in_) {
      return fmap(function (focus) {
        return setter(focus, in_);
      }, vf(getter(in_)));
    };
  };
};

var view = function view(lens, x) {
  return lens(Constantly)(x).val;
};
var over = function over(lens, f, x) {
  return lens(function (v) {
    return Identity(f(v));
  })(x).val;
};
var set = function set(lens, v, x) {
  return over(lens, function () {
    return v;
  }, x);
};

var lensProp = function lensProp(p) {
  return lens(prop(p), assoc(p));
};

/***/ }),
/* 1 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return Atom; });
/* harmony export (immutable) */ __webpack_exports__["c"] = atom;
/* harmony export (immutable) */ __webpack_exports__["d"] = deref;
/* harmony export (immutable) */ __webpack_exports__["e"] = swap;
/* harmony export (immutable) */ __webpack_exports__["f"] = reset;
/* harmony export (immutable) */ __webpack_exports__["g"] = dispatch;
/* harmony export (immutable) */ __webpack_exports__["h"] = addWatch;
/* harmony export (immutable) */ __webpack_exports__["i"] = removeWatch;
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__util__ = __webpack_require__(0);
function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _toArray(arr) { return Array.isArray(arr) ? arr : Array.from(arr); }




function prepareActions(context) {
  var actions = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var actionGenerators = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

  return Object.assign({}, actions, __webpack_require__.i(__WEBPACK_IMPORTED_MODULE_0__util__["d" /* mapObj */])(function (o) {
    return o(context);
  }, actionGenerators));
}

function makeDispatchFn(scope, actionFn) {
  return function (action) {
    var _action$split = action.split('.'),
        _action$split2 = _toArray(_action$split),
        first = _action$split2[0],
        rest = _action$split2.slice(1);

    for (var _len = arguments.length, params = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      params[_key - 1] = arguments[_key];
    }

    if (rest.length >= 1) {
      if (scope.modules.hasOwnProperty(first)) {
        var mod = scope.modules[first];
        mod.dispatch.apply(mod, [rest.join('.')].concat(params));
      } else {
        __webpack_require__.i(__WEBPACK_IMPORTED_MODULE_0__util__["b" /* warning */])(false, 'Unknown module on dispatch: ' + (scope.path || '') + '.' + first);
      }
    } else {
      if (scope.actions.hasOwnProperty(first)) {
        var actionPath = scope.path ? scope.path + '.' + action : action;
        var actionHandler = scope.actions[first];
        actionFn(scope, actionHandler, params, actionPath);
      } else {
        __webpack_require__.i(__WEBPACK_IMPORTED_MODULE_0__util__["b" /* warning */])(false, 'Unknown action: ' + (scope.path || '') + '.' + first);
      }
    }
  };
}

function makeAtomScope(parentScope, path, module, actionFn) {
  var subLens = __webpack_require__.i(__WEBPACK_IMPORTED_MODULE_0__util__["e" /* lensProp */])(path);
  var lens = parentScope.lens ? __webpack_require__.i(__WEBPACK_IMPORTED_MODULE_0__util__["a" /* compose */])(parentScope.lens, subLens) : subLens;
  var atom = parentScope.atom || parentScope;
  var subPath = parentScope.path ? parentScope.path + '.' + path : path;

  var scope = {
    atom: atom,
    lens: lens,
    path: subPath,
    swap: function swap(fn) {
      for (var _len2 = arguments.length, args = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
        args[_key2 - 1] = arguments[_key2];
      }

      return atom.reset(__webpack_require__.i(__WEBPACK_IMPORTED_MODULE_0__util__["f" /* over */])(lens, function (v) {
        return fn.apply(undefined, [v].concat(args));
      }, atom.deref()));
    },
    reset: function reset(newState) {
      return atom.reset(__webpack_require__.i(__WEBPACK_IMPORTED_MODULE_0__util__["g" /* set */])(lens, newState, atom.deref()));
    },
    deref: function deref() {
      return __webpack_require__.i(__WEBPACK_IMPORTED_MODULE_0__util__["h" /* view */])(lens, atom.deref());
    }
  };

  scope.modules = prepareModules(scope, module.modules);
  scope.actions = prepareActions(scope, module.actions, module.actionGenerators);
  scope.dispatch = makeDispatchFn(scope, actionFn);

  return scope;
}

function prepareModules(context, modules, actionFn) {
  return __webpack_require__.i(__WEBPACK_IMPORTED_MODULE_0__util__["i" /* mapObjIndexed */])(function (module, name) {
    return makeAtomScope(context, name, module, actionFn);
  }, modules);
}

function deriveInitialState(module) {
  return Object.assign({}, module.initialState || {}, recurseInitialState(module.modules || {}));
}

function recurseInitialState(modules) {
  return __webpack_require__.i(__WEBPACK_IMPORTED_MODULE_0__util__["d" /* mapObj */])(deriveInitialState, modules);
}

var Atom = function Atom() {
  var _this = this;

  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      _ref$initialState = _ref.initialState,
      initialState = _ref$initialState === undefined ? {} : _ref$initialState,
      _ref$actions = _ref.actions,
      actions = _ref$actions === undefined ? {} : _ref$actions,
      _ref$actionGenerators = _ref.actionGenerators,
      actionGenerators = _ref$actionGenerators === undefined ? {} : _ref$actionGenerators,
      _ref$modules = _ref.modules,
      modules = _ref$modules === undefined ? {} : _ref$modules;

  var middleware = arguments[1];

  _classCallCheck(this, Atom);

  this.reset = function (newState) {
    return _this._reset(_this.deref(), newState);
  };

  this.swap = function (fn) {
    for (var _len3 = arguments.length, args = Array(_len3 > 1 ? _len3 - 1 : 0), _key3 = 1; _key3 < _len3; _key3++) {
      args[_key3 - 1] = arguments[_key3];
    }

    var oldState = _this.deref();
    _this._reset(oldState, fn.apply(undefined, [oldState].concat(args)));
  };

  this.deref = function () {
    return _this.state;
  };

  this.addWatch = function (watcherFn) {
    var limitToPaths = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];

    var exists = _this.watches.indexOf(watcherFn) !== -1;
    __webpack_require__.i(__WEBPACK_IMPORTED_MODULE_0__util__["b" /* warning */])(!exists, 'addWatch: watcher already watching');

    if (!exists) _this.watches.push(watcherFn);
  };

  this.removeWatch = function (watcherFn) {
    var idx = _this.watches.indexOf(watcherFn);
    var exists = idx !== -1;
    __webpack_require__.i(__WEBPACK_IMPORTED_MODULE_0__util__["b" /* warning */])(exists, 'removeWatch: watcher not watching watching');

    if (exists) _this.watches.splice(idx, 1);
  };

  this.notifyWatches = function (oldState, newState) {
    _this.watches.forEach(function (sub) {
      // XXX: honour filtering
      sub(_this, newState, oldState);
    });
  };

  this.atom = this;
  this.watches = [];
  initialState = Object.assign({}, initialState, recurseInitialState(modules));
  this.actions = prepareActions(this, actions, actionGenerators);

  if (typeof middleware === 'undefined') middleware = function middleware(next) {
    return function () {
      return next.apply(undefined, arguments);
    };
  };

  middleware(function (finalInitialState, resetFn, actionFn) {
    _this.modules = prepareModules(_this, modules, actionFn);
    _this.dispatch = makeDispatchFn(_this, actionFn);
    _this._reset = resetFn;
    _this._reset({}, finalInitialState);
  })(initialState, function (oldState, newState) {
    _this.state = newState;
    _this.notifyWatches(oldState, newState);
  }, function (scope, actionHandler, params, actionPath) {
    if (typeof actionHandler === 'function') {
      actionHandler.apply(undefined, [scope].concat(_toConsumableArray(params)));
    } else {
      __webpack_require__.i(__WEBPACK_IMPORTED_MODULE_0__util__["b" /* warning */])(false, 'Unknown action handler type for action: ' + actionPath);
    }
  });
};

// functional interface:
//
function atom() {
  var middleware = void 0;
  var module = void 0;

  if (typeof (arguments.length <= 0 ? undefined : arguments[0]) === 'function') {
    middleware = arguments.length <= 0 ? undefined : arguments[0];
    module = arguments.length <= 1 ? undefined : arguments[1];
  } else {
    module = arguments.length <= 0 ? undefined : arguments[0];
  }

  if (typeof module === 'undefined') {
    return function (module) {
      return new Atom(module, middleware);
    };
  } else {
    return new Atom(module, middleware);
  }
}

function deref(atom) {
  return atom.deref();
}

function swap(atom, fn) {
  for (var _len4 = arguments.length, args = Array(_len4 > 2 ? _len4 - 2 : 0), _key4 = 2; _key4 < _len4; _key4++) {
    args[_key4 - 2] = arguments[_key4];
  }

  atom.swap.apply(atom, [fn].concat(args));
}

function reset(atom, newState) {
  atom.reset(newState);
}

function dispatch(atom, action) {
  for (var _len5 = arguments.length, args = Array(_len5 > 2 ? _len5 - 2 : 0), _key5 = 2; _key5 < _len5; _key5++) {
    args[_key5 - 2] = arguments[_key5];
  }

  atom.dispatch.apply(atom, [action].concat(args));
}

function addWatch(atom, watcherFn) {
  atom.addWatch(watcherFn);
}

function removeWatch(atom, watcherFn) {
  atom.removeWatch(watcherFn);
}

/***/ }),
/* 2 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (immutable) */ __webpack_exports__["a"] = makeStateLogger;
/* harmony export (immutable) */ __webpack_exports__["b"] = makeActionLogger;
var defaultStyles = {
  title: 'font-weight: lighter; color: gray;',
  titleDetails: 'font-weight: bold;',
  atom: 'font-weight: bold; color: royalblue;',
  oldState: 'font-weight: bold; color: gray;',
  newState: 'font-weight: bold; color: forestgreen;',
  params: 'font-weight: bold; color: mediumpurple;'
};

function makeStateLogger() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      _ref$styles = _ref.styles,
      styles = _ref$styles === undefined ? {} : _ref$styles;

  var actualStyles = Object.assign({}, defaultStyles, styles);

  return function stateLogger(oldState, newState) {
    console.group('%cState changed', actualStyles.title);
    console.log('%cold state: ', actualStyles.oldState, oldState);
    console.log('%cnew state: ', actualStyles.newState, newState);
    console.groupEnd();
  };
}

function makeActionLogger() {
  var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      _ref2$styles = _ref2.styles,
      styles = _ref2$styles === undefined ? defaultStyles : _ref2$styles,
      _ref2$printAtom = _ref2.printAtom,
      printAtom = _ref2$printAtom === undefined ? false : _ref2$printAtom;

  var actualStyles = Object.assign({}, defaultStyles, styles);

  return function actionLogger(atom, action, params) {
    console.group('%cAction called: %c' + action, actualStyles.title, actualStyles.titleDetails);
    if (printAtom) console.log('%catom:      ', actualStyles.atom, atom);
    console.log('%cparams:    ', actualStyles.params, params);
    console.groupEnd();
  };
}

/***/ }),
/* 3 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__internal_atom__ = __webpack_require__(1);
/* harmony reexport (binding) */ __webpack_require__.d(__webpack_exports__, "Atom", function() { return __WEBPACK_IMPORTED_MODULE_0__internal_atom__["a"]; });
/* harmony reexport (binding) */ __webpack_require__.d(__webpack_exports__, "registerActionHook", function() { return __WEBPACK_IMPORTED_MODULE_0__internal_atom__["registerActionHook"]; });
/* harmony reexport (binding) */ __webpack_require__.d(__webpack_exports__, "atom", function() { return __WEBPACK_IMPORTED_MODULE_0__internal_atom__["c"]; });
/* harmony reexport (binding) */ __webpack_require__.d(__webpack_exports__, "deref", function() { return __WEBPACK_IMPORTED_MODULE_0__internal_atom__["d"]; });
/* harmony reexport (binding) */ __webpack_require__.d(__webpack_exports__, "swap", function() { return __WEBPACK_IMPORTED_MODULE_0__internal_atom__["e"]; });
/* harmony reexport (binding) */ __webpack_require__.d(__webpack_exports__, "reset", function() { return __WEBPACK_IMPORTED_MODULE_0__internal_atom__["f"]; });
/* harmony reexport (binding) */ __webpack_require__.d(__webpack_exports__, "dispatch", function() { return __WEBPACK_IMPORTED_MODULE_0__internal_atom__["g"]; });
/* harmony reexport (binding) */ __webpack_require__.d(__webpack_exports__, "addWatch", function() { return __WEBPACK_IMPORTED_MODULE_0__internal_atom__["h"]; });
/* harmony reexport (binding) */ __webpack_require__.d(__webpack_exports__, "removeWatch", function() { return __WEBPACK_IMPORTED_MODULE_0__internal_atom__["i"]; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__internal_react__ = __webpack_require__(5);
/* harmony reexport (binding) */ __webpack_require__.d(__webpack_exports__, "Provider", function() { return __WEBPACK_IMPORTED_MODULE_1__internal_react__["a"]; });
/* harmony reexport (binding) */ __webpack_require__.d(__webpack_exports__, "connect", function() { return __WEBPACK_IMPORTED_MODULE_1__internal_react__["b"]; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__internal_logger__ = __webpack_require__(2);
/* harmony reexport (binding) */ __webpack_require__.d(__webpack_exports__, "makeStateLogger", function() { return __WEBPACK_IMPORTED_MODULE_2__internal_logger__["a"]; });
/* harmony reexport (binding) */ __webpack_require__.d(__webpack_exports__, "makeActionLogger", function() { return __WEBPACK_IMPORTED_MODULE_2__internal_logger__["b"]; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__internal_middleware__ = __webpack_require__(4);
/* harmony reexport (binding) */ __webpack_require__.d(__webpack_exports__, "wrapGenerator", function() { return __WEBPACK_IMPORTED_MODULE_3__internal_middleware__["a"]; });
/* harmony reexport (binding) */ __webpack_require__.d(__webpack_exports__, "generatorMiddleware", function() { return __WEBPACK_IMPORTED_MODULE_3__internal_middleware__["b"]; });
/* harmony reexport (binding) */ __webpack_require__.d(__webpack_exports__, "applyLogger", function() { return __WEBPACK_IMPORTED_MODULE_3__internal_middleware__["c"]; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__internal_util__ = __webpack_require__(0);
/* harmony reexport (binding) */ __webpack_require__.d(__webpack_exports__, "compose", function() { return __WEBPACK_IMPORTED_MODULE_4__internal_util__["a"]; });










/***/ }),
/* 4 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (immutable) */ __webpack_exports__["a"] = wrapGenerator;
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return generatorMiddleware; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "c", function() { return applyLogger; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__util__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__logger__ = __webpack_require__(2);



function wrapGenerator(genFn) {
  for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    args[_key - 1] = arguments[_key];
  }

  return function (scope) {
    var gen = genFn.apply(undefined, [scope].concat(args));

    var _gen$next = gen.next(),
        done = _gen$next.done;

    __webpack_require__.i(__WEBPACK_IMPORTED_MODULE_0__util__["b" /* warning */])(!done, 'wrapGenerator: generator function already completed!');

    return gen;
  };
}

var generatorMiddleware = function generatorMiddleware(next) {
  return function (initialState, resetFn, actionFn) {
    var wrappedActionFn = function wrappedActionFn(scope, actionHandler, params, actionPath) {
      if (__webpack_require__.i(__WEBPACK_IMPORTED_MODULE_0__util__["c" /* isIterator */])(actionHandler)) actionFn(scope, function (scope) {
        for (var _len2 = arguments.length, params = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
          params[_key2 - 1] = arguments[_key2];
        }

        return actionHandler.next(params);
      }, params, actionPath);else actionFn(scope, actionHandler, params, actionPath);
    };

    next(initialState, resetFn, wrappedActionFn);
  };
};

var applyLogger = function applyLogger(stateLogger, actionLogger) {
  if (typeof stateLogger === 'undefined') stateLogger = __webpack_require__.i(__WEBPACK_IMPORTED_MODULE_1__logger__["a" /* makeStateLogger */])();
  if (typeof actionLogger === 'undefined') actionLogger = __webpack_require__.i(__WEBPACK_IMPORTED_MODULE_1__logger__["b" /* makeActionLogger */])();

  return function (next) {
    return function (initialState, resetFn, actionFn) {
      var wrappedResetFn = function wrappedResetFn(oldState, newState) {
        if (stateLogger) stateLogger(oldState, newState);

        resetFn(oldState, newState);
      };

      var wrappedActionFn = function wrappedActionFn(scope, actionHandler, params, actionPath) {
        if (actionLogger) actionLogger(scope.atom, actionPath, params);

        actionFn(scope, actionHandler, params, actionPath);
      };

      next(initialState, wrappedResetFn, wrappedActionFn);
    };
  };
};

/***/ }),
/* 5 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return Provider; });
/* harmony export (immutable) */ __webpack_exports__["b"] = connect;
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(7);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_prop_types__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_prop_types___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_prop_types__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__atom__ = __webpack_require__(1);
var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }





var Provider = function (_React$Component) {
  _inherits(Provider, _React$Component);

  _createClass(Provider, [{
    key: 'getChildContext',
    value: function getChildContext() {
      return { stateAtom: this.stateAtom };
    }
  }]);

  function Provider(props, context) {
    _classCallCheck(this, Provider);

    var _this = _possibleConstructorReturn(this, (Provider.__proto__ || Object.getPrototypeOf(Provider)).call(this, props, context));

    _this.stateAtom = props.stateAtom;
    return _this;
  }

  _createClass(Provider, [{
    key: 'render',
    value: function render() {
      return __WEBPACK_IMPORTED_MODULE_0_react___default.a.Children.only(this.props.children);
    }
  }]);

  return Provider;
}(__WEBPACK_IMPORTED_MODULE_0_react___default.a.Component);

Provider.propTypes = {
  stateAtom: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.instanceOf(__WEBPACK_IMPORTED_MODULE_2__atom__["a" /* Atom */]),
  children: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.node.isRequired
};
Provider.childContextTypes = {
  stateAtom: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.instanceOf(__WEBPACK_IMPORTED_MODULE_2__atom__["a" /* Atom */])
};
var getDisplayName = function getDisplayName(WrappedComponent) {
  return WrappedComponent.displayName || WrappedComponent.name || 'Component';
};

function connect(mapStateFn, mapActionsFn) {
  var equalFn = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;

  if (typeof equalFn !== 'function') equalFn = function equalFn(a, b) {
    return a === b;
  };

  return function connectHOC(WrappedComponent) {
    var _class, _temp;

    return _temp = _class = function (_React$PureComponent) {
      _inherits(_class, _React$PureComponent);

      function _class(props, context) {
        _classCallCheck(this, _class);

        var _this2 = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, props, context));

        _this2.stateUpdateHandler = function () {
          if (mapStateFn) {
            var newState = mapStateFn(_this2.context.stateAtom.deref(), _this2.props);
            if (!equalFn(_this2.state, newState)) _this2.setState(newState);
          }
        };

        if (mapStateFn) _this2.state = mapStateFn(context.stateAtom.deref(), props);
        if (mapActionsFn) _this2.actions = mapActionsFn(context.stateAtom, props);

        context.stateAtom.addWatch(_this2.stateUpdateHandler);
        return _this2;
      }

      _createClass(_class, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
          this.refreshActions(this.props);
          this.stateUpdateHandler();
        }
      }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
          this.refreshActions(nextProps);
          if (mapStateFn) this.setState(mapStateFn(this.context.stateAtom.deref(), nextProps));
        }
      }, {
        key: 'refreshActions',
        value: function refreshActions(props) {
          if (mapActionsFn) this.actions = mapActionsFn(this.context.stateAtom, props);
        }
      }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
          this.context.stateAtom.removeWatch(this.stateUpdateHandler);
        }
      }, {
        key: 'render',
        value: function render() {
          return __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(WrappedComponent, Object.assign({}, this.props, this.actions, this.state));
        }
      }]);

      return _class;
    }(__WEBPACK_IMPORTED_MODULE_0_react___default.a.PureComponent), _class.displayName = 'BindAtom(' + getDisplayName(WrappedComponent) + ')', _class.contextTypes = {
      stateAtom: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.instanceOf(__WEBPACK_IMPORTED_MODULE_2__atom__["a" /* Atom */])
    }, _temp;
  };
}

// const mapState = (state, ownProps) => ({
//  notes: state.notes,
// })
//
// const mapActions = (atom, ownProps) => ({
//   addNote: (...args) => atom.dispatch('notes.add', ...args),
// })
//
// export default connect(mapState, mapActions)(SomeComponent)

/***/ }),
/* 6 */
/***/ (function(module, exports) {

module.exports = __WEBPACK_EXTERNAL_MODULE_6__;

/***/ }),
/* 7 */
/***/ (function(module, exports) {

module.exports = __WEBPACK_EXTERNAL_MODULE_7__;

/***/ }),
/* 8 */
/***/ (function(module, exports, __webpack_require__) {

module.exports = __webpack_require__(3);


/***/ })
/******/ ]);
});
//# sourceMappingURL=re-atom.es5.js.map