(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("prop-types"), require("react"));
	else if(typeof define === 'function' && define.amd)
		define(["prop-types", "react"], factory);
	else if(typeof exports === 'object')
		exports["re-atom"] = factory(require("prop-types"), require("react"));
	else
		root["re-atom"] = factory(root["PropTypes"], root["React"]);
})(this, function(__WEBPACK_EXTERNAL_MODULE_6__, __WEBPACK_EXTERNAL_MODULE_7__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// identity function for calling harmony imports with the correct context
/******/ 	__webpack_require__.i = function(value) { return value; };
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 8);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (immutable) */ __webpack_exports__["b"] = warning;
/* harmony export (immutable) */ __webpack_exports__["i"] = mapObjIndexed;
/* harmony export (immutable) */ __webpack_exports__["d"] = mapObj;
/* harmony export (immutable) */ __webpack_exports__["a"] = compose;
var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function warning(condition, message) {
  if (!condition && typeof console !== undefined) {
    console.error('Warning: ' + message);
    try {
      // This error was thrown as a convenience so that you can use this stack
      // to find the callsite that caused this warning to fire.
      throw new Error(message);
    } catch (e) {}
  }
}

function mapObjIndexed(fn, obj) {
  return Object.keys(obj || {}).reduce((r, key) => Object.assign(r, { [key]: fn(obj[key], key) }), {});
}

function mapObj(fn, obj) {
  return Object.keys(obj || {}).reduce((r, key) => Object.assign(r, { [key]: fn(obj[key]) }), {});
}

function compose(...fns) {
  const outerFn = fns.pop();

  return (...args) => fns.reduceRight((acc, fn) => fn(acc), outerFn(...args));
}

// XXX: wrap in currying goodness
// XXX: check transpilation of { ...obj }
const assoc = p => (val, obj) => _extends({}, obj, { [p]: val });
/* unused harmony export assoc */

const prop = p => obj => obj[p];
/* unused harmony export prop */


const isIterator = o => o && typeof o.next === 'function';
/* harmony export (immutable) */ __webpack_exports__["c"] = isIterator;


// Simple van Laarhoven lens implementation

const fmap = (fn, functor) => functor.map(fn);

const Identity = val => ({
  val,
  map: f => Identity(f(val))
});

const Constantly = val => ({
  val,
  map: function (f) {
    return this;
  }
});

const lens = (getter, setter) => vf => in_ => fmap(focus => setter(focus, in_), vf(getter(in_)));
/* unused harmony export lens */


const view = (lens, x) => lens(Constantly)(x).val;
/* harmony export (immutable) */ __webpack_exports__["h"] = view;

const over = (lens, f, x) => lens(v => Identity(f(v)))(x).val;
/* harmony export (immutable) */ __webpack_exports__["f"] = over;

const set = (lens, v, x) => over(lens, () => v, x);
/* harmony export (immutable) */ __webpack_exports__["g"] = set;


const lensProp = p => lens(prop(p), assoc(p));
/* harmony export (immutable) */ __webpack_exports__["e"] = lensProp;


/***/ }),
/* 1 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (immutable) */ __webpack_exports__["c"] = atom;
/* harmony export (immutable) */ __webpack_exports__["d"] = deref;
/* harmony export (immutable) */ __webpack_exports__["e"] = swap;
/* harmony export (immutable) */ __webpack_exports__["f"] = reset;
/* harmony export (immutable) */ __webpack_exports__["g"] = dispatch;
/* harmony export (immutable) */ __webpack_exports__["h"] = addWatch;
/* harmony export (immutable) */ __webpack_exports__["i"] = removeWatch;
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__util__ = __webpack_require__(0);



function prepareActions(context, actions = {}, actionGenerators = {}) {
  return Object.assign({}, actions, __webpack_require__.i(__WEBPACK_IMPORTED_MODULE_0__util__["d" /* mapObj */])(o => o(context), actionGenerators));
}

function makeDispatchFn(scope, actionFn) {
  return function (action, ...params) {
    const [first, ...rest] = action.split('.');

    if (rest.length >= 1) {
      if (scope.modules.hasOwnProperty(first)) {
        const mod = scope.modules[first];
        mod.dispatch(rest.join('.'), ...params);
      } else {
        __webpack_require__.i(__WEBPACK_IMPORTED_MODULE_0__util__["b" /* warning */])(false, `Unknown module on dispatch: ${scope.path || ''}.${first}`);
      }
    } else {
      if (scope.actions.hasOwnProperty(first)) {
        const actionPath = scope.path ? `${scope.path}.${action}` : action;
        const actionHandler = scope.actions[first];
        actionFn(scope, actionHandler, params, actionPath);
      } else {
        __webpack_require__.i(__WEBPACK_IMPORTED_MODULE_0__util__["b" /* warning */])(false, `Unknown action: ${scope.path || ''}.${first}`);
      }
    }
  };
}

function makeAtomScope(parentScope, path, module, actionFn) {
  const subLens = __webpack_require__.i(__WEBPACK_IMPORTED_MODULE_0__util__["e" /* lensProp */])(path);
  const lens = parentScope.lens ? __webpack_require__.i(__WEBPACK_IMPORTED_MODULE_0__util__["a" /* compose */])(parentScope.lens, subLens) : subLens;
  const atom = parentScope.atom || parentScope;
  const subPath = parentScope.path ? `${parentScope.path}.${path}` : path;

  let scope = {
    atom,
    lens,
    path: subPath,
    swap: (fn, ...args) => atom.reset(__webpack_require__.i(__WEBPACK_IMPORTED_MODULE_0__util__["f" /* over */])(lens, v => fn(v, ...args), atom.deref())),
    reset: newState => atom.reset(__webpack_require__.i(__WEBPACK_IMPORTED_MODULE_0__util__["g" /* set */])(lens, newState, atom.deref())),
    deref: () => __webpack_require__.i(__WEBPACK_IMPORTED_MODULE_0__util__["h" /* view */])(lens, atom.deref())
  };

  scope.modules = prepareModules(scope, module.modules);
  scope.actions = prepareActions(scope, module.actions, module.actionGenerators);
  scope.dispatch = makeDispatchFn(scope, actionFn);

  return scope;
}

function prepareModules(context, modules, actionFn) {
  return __webpack_require__.i(__WEBPACK_IMPORTED_MODULE_0__util__["i" /* mapObjIndexed */])((module, name) => {
    return makeAtomScope(context, name, module, actionFn);
  }, modules);
}

function deriveInitialState(module) {
  return Object.assign({}, module.initialState || {}, recurseInitialState(module.modules || {}));
}

function recurseInitialState(modules) {
  return __webpack_require__.i(__WEBPACK_IMPORTED_MODULE_0__util__["d" /* mapObj */])(deriveInitialState, modules);
}

class Atom {
  constructor({
    initialState = {},
    actions = {},
    actionGenerators = {},
    modules = {}
  } = {}, middleware) {
    this.reset = newState => this._reset(this.deref(), newState);

    this.swap = (fn, ...args) => {
      const oldState = this.deref();
      this._reset(oldState, fn(oldState, ...args));
    };

    this.deref = () => this.state;

    this.addWatch = (watcherFn, limitToPaths = []) => {
      const exists = this.watches.indexOf(watcherFn) !== -1;
      __webpack_require__.i(__WEBPACK_IMPORTED_MODULE_0__util__["b" /* warning */])(!exists, 'addWatch: watcher already watching');

      if (!exists) this.watches.push(watcherFn);
    };

    this.removeWatch = watcherFn => {
      const idx = this.watches.indexOf(watcherFn);
      const exists = idx !== -1;
      __webpack_require__.i(__WEBPACK_IMPORTED_MODULE_0__util__["b" /* warning */])(exists, 'removeWatch: watcher not watching watching');

      if (exists) this.watches.splice(idx, 1);
    };

    this.notifyWatches = (oldState, newState) => {
      this.watches.forEach(sub => {
        // XXX: honour filtering
        sub(this, newState, oldState);
      });
    };

    this.atom = this;
    this.watches = [];
    initialState = Object.assign({}, initialState, recurseInitialState(modules));
    this.actions = prepareActions(this, actions, actionGenerators);

    if (typeof middleware === 'undefined') middleware = next => (...args) => next(...args);

    middleware((finalInitialState, resetFn, actionFn) => {
      this.modules = prepareModules(this, modules, actionFn);
      this.dispatch = makeDispatchFn(this, actionFn);
      this._reset = resetFn;
      this._reset({}, finalInitialState);
    })(initialState, (oldState, newState) => {
      this.state = newState;
      this.notifyWatches(oldState, newState);
    }, (scope, actionHandler, params, actionPath) => {
      if (typeof actionHandler === 'function') {
        actionHandler(scope, ...params);
      } else {
        __webpack_require__.i(__WEBPACK_IMPORTED_MODULE_0__util__["b" /* warning */])(false, `Unknown action handler type for action: ${actionPath}`);
      }
    });
  }

}
/* harmony export (immutable) */ __webpack_exports__["a"] = Atom;


// functional interface:
//
function atom(...args) {
  let middleware;
  let module;

  if (typeof args[0] === 'function') {
    middleware = args[0];
    module = args[1];
  } else {
    module = args[0];
  }

  if (typeof module === 'undefined') {
    return function (module) {
      return new Atom(module, middleware);
    };
  } else {
    return new Atom(module, middleware);
  }
}

function deref(atom) {
  return atom.deref();
}

function swap(atom, fn, ...args) {
  atom.swap(fn, ...args);
}

function reset(atom, newState) {
  atom.reset(newState);
}

function dispatch(atom, action, ...args) {
  atom.dispatch(action, ...args);
}

function addWatch(atom, watcherFn) {
  atom.addWatch(watcherFn);
}

function removeWatch(atom, watcherFn) {
  atom.removeWatch(watcherFn);
}

/***/ }),
/* 2 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (immutable) */ __webpack_exports__["a"] = makeStateLogger;
/* harmony export (immutable) */ __webpack_exports__["b"] = makeActionLogger;
const defaultStyles = {
  title: 'font-weight: lighter; color: gray;',
  titleDetails: 'font-weight: bold;',
  atom: `font-weight: bold; color: royalblue;`,
  oldState: `font-weight: bold; color: gray;`,
  newState: `font-weight: bold; color: forestgreen;`,
  params: `font-weight: bold; color: mediumpurple;`
};

function makeStateLogger({ styles = {} } = {}) {
  const actualStyles = Object.assign({}, defaultStyles, styles);

  return function stateLogger(oldState, newState) {
    console.group('%cState changed', actualStyles.title);
    console.log('%cold state: ', actualStyles.oldState, oldState);
    console.log('%cnew state: ', actualStyles.newState, newState);
    console.groupEnd();
  };
}

function makeActionLogger({ styles = defaultStyles, printAtom = false } = {}) {
  const actualStyles = Object.assign({}, defaultStyles, styles);

  return function actionLogger(atom, action, params) {
    console.group(`%cAction called: %c${action}`, actualStyles.title, actualStyles.titleDetails);
    if (printAtom) console.log('%catom:      ', actualStyles.atom, atom);
    console.log('%cparams:    ', actualStyles.params, params);
    console.groupEnd();
  };
}

/***/ }),
/* 3 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__internal_atom__ = __webpack_require__(1);
/* harmony reexport (binding) */ __webpack_require__.d(__webpack_exports__, "Atom", function() { return __WEBPACK_IMPORTED_MODULE_0__internal_atom__["a"]; });
/* harmony reexport (binding) */ __webpack_require__.d(__webpack_exports__, "registerActionHook", function() { return __WEBPACK_IMPORTED_MODULE_0__internal_atom__["registerActionHook"]; });
/* harmony reexport (binding) */ __webpack_require__.d(__webpack_exports__, "atom", function() { return __WEBPACK_IMPORTED_MODULE_0__internal_atom__["c"]; });
/* harmony reexport (binding) */ __webpack_require__.d(__webpack_exports__, "deref", function() { return __WEBPACK_IMPORTED_MODULE_0__internal_atom__["d"]; });
/* harmony reexport (binding) */ __webpack_require__.d(__webpack_exports__, "swap", function() { return __WEBPACK_IMPORTED_MODULE_0__internal_atom__["e"]; });
/* harmony reexport (binding) */ __webpack_require__.d(__webpack_exports__, "reset", function() { return __WEBPACK_IMPORTED_MODULE_0__internal_atom__["f"]; });
/* harmony reexport (binding) */ __webpack_require__.d(__webpack_exports__, "dispatch", function() { return __WEBPACK_IMPORTED_MODULE_0__internal_atom__["g"]; });
/* harmony reexport (binding) */ __webpack_require__.d(__webpack_exports__, "addWatch", function() { return __WEBPACK_IMPORTED_MODULE_0__internal_atom__["h"]; });
/* harmony reexport (binding) */ __webpack_require__.d(__webpack_exports__, "removeWatch", function() { return __WEBPACK_IMPORTED_MODULE_0__internal_atom__["i"]; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__internal_react__ = __webpack_require__(5);
/* harmony reexport (binding) */ __webpack_require__.d(__webpack_exports__, "Provider", function() { return __WEBPACK_IMPORTED_MODULE_1__internal_react__["a"]; });
/* harmony reexport (binding) */ __webpack_require__.d(__webpack_exports__, "connect", function() { return __WEBPACK_IMPORTED_MODULE_1__internal_react__["b"]; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__internal_logger__ = __webpack_require__(2);
/* harmony reexport (binding) */ __webpack_require__.d(__webpack_exports__, "makeStateLogger", function() { return __WEBPACK_IMPORTED_MODULE_2__internal_logger__["a"]; });
/* harmony reexport (binding) */ __webpack_require__.d(__webpack_exports__, "makeActionLogger", function() { return __WEBPACK_IMPORTED_MODULE_2__internal_logger__["b"]; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__internal_middleware__ = __webpack_require__(4);
/* harmony reexport (binding) */ __webpack_require__.d(__webpack_exports__, "wrapGenerator", function() { return __WEBPACK_IMPORTED_MODULE_3__internal_middleware__["a"]; });
/* harmony reexport (binding) */ __webpack_require__.d(__webpack_exports__, "generatorMiddleware", function() { return __WEBPACK_IMPORTED_MODULE_3__internal_middleware__["b"]; });
/* harmony reexport (binding) */ __webpack_require__.d(__webpack_exports__, "applyLogger", function() { return __WEBPACK_IMPORTED_MODULE_3__internal_middleware__["c"]; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__internal_util__ = __webpack_require__(0);
/* harmony reexport (binding) */ __webpack_require__.d(__webpack_exports__, "compose", function() { return __WEBPACK_IMPORTED_MODULE_4__internal_util__["a"]; });










/***/ }),
/* 4 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (immutable) */ __webpack_exports__["a"] = wrapGenerator;
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__util__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__logger__ = __webpack_require__(2);



function wrapGenerator(genFn, ...args) {
  return function (scope) {
    const gen = genFn(scope, ...args);
    const { done } = gen.next();

    __webpack_require__.i(__WEBPACK_IMPORTED_MODULE_0__util__["b" /* warning */])(!done, 'wrapGenerator: generator function already completed!');

    return gen;
  };
}

const generatorMiddleware = next => (initialState, resetFn, actionFn) => {
  const wrappedActionFn = (scope, actionHandler, params, actionPath) => {
    if (__webpack_require__.i(__WEBPACK_IMPORTED_MODULE_0__util__["c" /* isIterator */])(actionHandler)) actionFn(scope, (scope, ...params) => actionHandler.next(params), params, actionPath);else actionFn(scope, actionHandler, params, actionPath);
  };

  next(initialState, resetFn, wrappedActionFn);
};
/* harmony export (immutable) */ __webpack_exports__["b"] = generatorMiddleware;


const applyLogger = (stateLogger, actionLogger) => {
  if (typeof stateLogger === 'undefined') stateLogger = __webpack_require__.i(__WEBPACK_IMPORTED_MODULE_1__logger__["a" /* makeStateLogger */])();
  if (typeof actionLogger === 'undefined') actionLogger = __webpack_require__.i(__WEBPACK_IMPORTED_MODULE_1__logger__["b" /* makeActionLogger */])();

  return next => (initialState, resetFn, actionFn) => {
    const wrappedResetFn = (oldState, newState) => {
      if (stateLogger) stateLogger(oldState, newState);

      resetFn(oldState, newState);
    };

    const wrappedActionFn = (scope, actionHandler, params, actionPath) => {
      if (actionLogger) actionLogger(scope.atom, actionPath, params);

      actionFn(scope, actionHandler, params, actionPath);
    };

    next(initialState, wrappedResetFn, wrappedActionFn);
  };
};
/* harmony export (immutable) */ __webpack_exports__["c"] = applyLogger;


/***/ }),
/* 5 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (immutable) */ __webpack_exports__["b"] = connect;
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(7);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_prop_types__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_prop_types___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_prop_types__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__atom__ = __webpack_require__(1);




class Provider extends __WEBPACK_IMPORTED_MODULE_0_react___default.a.Component {

  getChildContext() {
    return { stateAtom: this.stateAtom };
  }

  constructor(props, context) {
    super(props, context);
    this.stateAtom = props.stateAtom;
  }

  render() {
    return __WEBPACK_IMPORTED_MODULE_0_react___default.a.Children.only(this.props.children);
  }
}
/* harmony export (immutable) */ __webpack_exports__["a"] = Provider;


Provider.propTypes = {
  stateAtom: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.instanceOf(__WEBPACK_IMPORTED_MODULE_2__atom__["a" /* Atom */]),
  children: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.node.isRequired
};
Provider.childContextTypes = {
  stateAtom: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.instanceOf(__WEBPACK_IMPORTED_MODULE_2__atom__["a" /* Atom */])
};
const getDisplayName = WrappedComponent => WrappedComponent.displayName || WrappedComponent.name || 'Component';

function connect(mapStateFn, mapActionsFn, equalFn = null) {
  if (typeof equalFn !== 'function') equalFn = (a, b) => a === b;

  return function connectHOC(WrappedComponent) {
    var _class, _temp;

    return _temp = _class = class extends __WEBPACK_IMPORTED_MODULE_0_react___default.a.PureComponent {

      constructor(props, context) {
        super(props, context);

        this.stateUpdateHandler = () => {
          if (mapStateFn) {
            const newState = mapStateFn(this.context.stateAtom.deref(), this.props);
            if (!equalFn(this.state, newState)) this.setState(newState);
          }
        };

        if (mapStateFn) this.state = mapStateFn(context.stateAtom.deref(), props);
        if (mapActionsFn) this.actions = mapActionsFn(context.stateAtom, props);

        context.stateAtom.addWatch(this.stateUpdateHandler);
      }

      componentDidMount() {
        this.refreshActions(this.props);
        this.stateUpdateHandler();
      }

      componentWillReceiveProps(nextProps) {
        this.refreshActions(nextProps);
        if (mapStateFn) this.setState(mapStateFn(this.context.stateAtom.deref(), nextProps));
      }

      refreshActions(props) {
        if (mapActionsFn) this.actions = mapActionsFn(this.context.stateAtom, props);
      }

      componentWillUnmount() {
        this.context.stateAtom.removeWatch(this.stateUpdateHandler);
      }

      render() {
        return __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(WrappedComponent, Object.assign({}, this.props, this.actions, this.state));
      }
    }, _class.displayName = `BindAtom(${getDisplayName(WrappedComponent)})`, _class.contextTypes = {
      stateAtom: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.instanceOf(__WEBPACK_IMPORTED_MODULE_2__atom__["a" /* Atom */])
    }, _temp;
  };
}

// const mapState = (state, ownProps) => ({
//  notes: state.notes,
// })
//
// const mapActions = (atom, ownProps) => ({
//   addNote: (...args) => atom.dispatch('notes.add', ...args),
// })
//
// export default connect(mapState, mapActions)(SomeComponent)

/***/ }),
/* 6 */
/***/ (function(module, exports) {

module.exports = __WEBPACK_EXTERNAL_MODULE_6__;

/***/ }),
/* 7 */
/***/ (function(module, exports) {

module.exports = __WEBPACK_EXTERNAL_MODULE_7__;

/***/ }),
/* 8 */
/***/ (function(module, exports, __webpack_require__) {

module.exports = __webpack_require__(3);


/***/ })
/******/ ]);
});
//# sourceMappingURL=re-atom.js.map