import { atom, swap, reset, deref, dispatch, addWatch, removeWatch, wrapGenerator } from '../src/index'

export const mkAtomFixture1 = () => atom({
  initialState: {
    a: 1,
  },
  modules: {
    b: {
      initialState: {
        val: 3,
      },
      actions: {
        decBy: function(scope, decQty) {
          swap(scope, oldState => ({ ...oldState, val: oldState.val - decQty }))
        }
      },
      modules: {
        c: {
          initialState: {},
        }
      },
    },
  },
  actions: {
    incBy: function(scope, incQty) {
      swap(scope, oldState => ({ ...oldState, a: oldState.a + incQty }))
    }
  },
})

export const mkAtomFixture2 = atom => atom({
  initialState: {
    a: "bcd",
  },
  modules: {
    b: {
      initialState: {
        val: 3,
      }
    }
  }
})
